//---------------------------------------------------------------------------

#include <vcl.h>
#include <iostream>
#include <iterator>
#include <set>
#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

template <class T>
inline void PRINT_ELEMENTS (const T& coll, const char* optcstr="")
{
  typename T::const_iterator pos;
  std::cout << ToRus(optcstr);
  for (pos=coll.begin(); pos!=coll.end(); ++pos) {
    std::cout <<*pos <<' ';
  }
  std::cout << std::endl;
}

//    
template <class T>
class RuntimeCmp {
  public: 
    enum cmp_mode {normal, reverse};
  private: 
    cmp_mode mode;
  public:
    //    
    // -     normal 
    RuntimeCmp (cmp_mode m=normal) : mode(m) { }

    //  
    bool operator() (const T& t1, const T& t2) const { 
      return mode == normal ? t1 < t2 : t2 < t1;
    }

    //    
    bool operator== (const RuntimeCmp& rc) { 
      return mode = rc.mode;
    }
};

//  ,     
typedef set<int,RuntimeCmp<int> > IntSet;

//   
void fill (IntSet& set);


int main(int argc, char* argv[])
{
  // ,        
  //  -     
  IntSet coll1;
  fill(coll1);
  PRINT_ELEMENTS (coll1, "coll1: ");

  //        
  RuntimeCmp<int> reverse_order(RuntimeCmp<int>::reverse);

  // ,    
  //     
  IntSet coll2(reverse_order);
  fill(coll2);
  PRINT_ELEMENTS (coll2, "coll2: ");

  //     
  coll1 = coll2;
  coll1.insert(3);
  PRINT_ELEMENTS (coll1, "coll1: ");
 
  //   ...
  if (coll1.value_comp() == coll2.value_comp()) {
    cout << ToRus("coll1  coll2    ") << endl;
  }
  else {
    cout << ToRus("coll1  coll2    ") << endl;
  }

  getch();
  return 0;
}

void fill (IntSet& set)
{
  //     
  set.insert(4);
  set.insert(7);
  set.insert(5);
  set.insert(1);
  set.insert(6);
  set.insert(2);
  set.insert(5);
}
//---------------------------------------------------------------------------
